#include <iostream>
#include <cstdio>
using namespace std;
struct point{
       int x, w;
};
int n, tree[1 << 20], x[1 << 20], w[1<<20], sum;
void update(int s, int p, int l, int r, int i){
    tree[i] += s;
    int mid = (l + r) / 2;
    if ( l == r ) return;
    if ( p <= mid )update(s, p, l, mid, i * 2 + 1);
    else update(s, p, mid + 1, r, i * 2 + 2);
}
int find(int l1, int r1, int l, int r, int i){
    if ( l >= l1 && r <= r1 ) return tree[i]; 
//    cout << l << " " << r << " ";
    int mid = (l + r) / 2, p = 0;
    if ( l1 <= mid ) p += find(l1, r1, l, mid, i * 2 + 1 );
    if ( r1 >= mid + 1 ) p += find(l1, r1, mid + 1, r, i * 2 + 2);
    return p;
}
int main(){
    int L;
    cin >> n >> L;
    for ( int i = 0; i < n; ++i ){
        scanf("%d%d",&x[i], &w[i]);
        update(w[i], x[i], 0, 100001, 0);
    }
    int mx = 0;
    for ( int i = 0; i <= 100001; ++i ){
        int t = min( x[i] + L, 100001);
//        cout << x[i] << " " << x[i] + L << endl;
//        cout << find(x[i], t, 0, 100001, 0) << endl;
        mx = max(mx, find(x[i], t, 0, 100001, 0));
        
    }
    cout << mx << endl;
}
